﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Windows.Threading;
using System.Windows.Media.Animation;

namespace xamLinearGauge_barmarkers
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public double BarMarkerValue
        {
            get { return (double)GetValue(BarMarkerValueProperty); }
            set { SetValue(BarMarkerValueProperty, value); }
        }

        // Using a DependencyProperty as the backing store for BarMarkerValue.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty BarMarkerValueProperty =
            DependencyProperty.Register("BarMarkerValue", typeof(double), typeof(MainWindow), new UIPropertyMetadata(0.0));

        private double _targetValue;

        Random randomValue = new Random();

        public MainWindow()
        {
            this.DataContext = this;

            InitializeComponent();

            InitTimer();
        }

        public void InitTimer()
        {
            DispatcherTimer timer = new DispatcherTimer();
            timer.Tick += OnTimerTick;
            timer.Interval = new TimeSpan(0, 0, 1); // 1 second
            timer.Start();
        }

        private void OnTimerTick(object sender, EventArgs e)
        {
            // Update the target value.
            _targetValue = randomValue.Next(-25, 25);

            DoubleAnimation barmarkerAnimation = new DoubleAnimation();
            barmarkerAnimation.From = BarMarkerValue;
            barmarkerAnimation.To = _targetValue;
            barmarkerAnimation.Duration = new Duration(new TimeSpan(0, 0, 1)); // 1 second

            this.BeginAnimation(MainWindow.BarMarkerValueProperty, barmarkerAnimation);
        }
    }
}
